///File : MainFrame.hpp
//------------------------------------------------------------------------------
/*
    This file is part of forbidden2forget.

    Forbidden2forget is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Forbidden2forget is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with forbidden2forget.  If not, see <http://www.gnu.org/licenses/>.
*/
#if not defined MAIN_FRAME_HPP_FORBIDDEN_2_FORGET
#define MAIN_FRAME_HPP_FORBIDDEN_2_FORGET

//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/print.h>
#include <wx/notebook.h>
#include <wx/stdpaths.h>
//------------------------------------------------------------------------------
#include "f2fverbs/F2fVerbs.hpp"
//------------------------------------------------------------------------------
#include "Printing.hpp"
#include "PanelVerbs.hpp"
#include "PanelStats.hpp"
#include "DialogAbout.hpp"
//------------------------------------------------------------------------------

class PanelVerbs; //On déclare PanelVerbs avant pr pouvoir l'utiliser juste après.
class PanelStats; //On déclare PanelVerbs avant pr pouvoir l'utiliser juste après.

class MainFrame : public wxFrame
{
public:
    MainFrame(const wxString& title, const wxPoint& pos, const wxSize& size, long style = wxDEFAULT_FRAME_STYLE);
    void OnQuit(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
    void OnOpen(wxCommandEvent& event);
    void OnSave(wxCommandEvent& event);
    void OnClose(wxCommandEvent& event);
    void OnFrameClose(wxCloseEvent& event);
    void OnChgPassword(wxCommandEvent& event);
    void OnPrintPreview(wxCommandEvent& event);
    void OnPrint(wxCommandEvent& event);

    void OnNew5e(wxCommandEvent& event);
    void OnNew4e(wxCommandEvent& event);
    void OnNew3e(wxCommandEvent& event);
    void OnNew2nd(wxCommandEvent& event);

    void LoadFile(wxString fileName);

    void ResetBiginWorkDateTime();
    wxDateTime GetBiginWorkDateTime();

    void EnableMenus(bool enable);

    F2fVerbs* GetF2fVerbs();
    void RefreshPanelStats();
protected:
    wxNotebook *m_MainNotebook;
    PanelVerbs *m_MyPanelVerbs;
    PanelStats *m_MyPanelStats;

    wxDateTime m_BiginWorkDateTime;

    F2fVerbs m_F2fVerbs;

    wxMenuItem *m_MenuItemSave, *m_MenuItemChgPassword, *m_MenuItemClose, *m_MenuItemPrintPreview, *m_MenuItemPrint;

    wxMenu *m_FileMenu, *m_HelpMenu;
    wxMenuBar *m_MenuBar;

    DECLARE_EVENT_TABLE()
    enum {Id_ChgPassword, Id_NewLvl5e, Id_NewLvl4e, Id_NewLvl3e, Id_NewLvl2nd};
};

#endif //MAIN_FRAME_HPP_FORBIDDEN_2_FORGET
