///File : Printing.hpp
//------------------------------------------------------------------------------
/*
    This file is part of forbidden2forget.

    Forbidden2forget is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Forbidden2forget is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with forbidden2forget.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#if not defined PRINTING_HPP_FORBIDDEN_2_FORGET
#define PRINTING_HPP_FORBIDDEN_2_FORGET

//------------------------------------------------------------------------------
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
//------------------------------------------------------------------------------
#include <wx/print.h>
#include <wx/stdpaths.h>

#if !wxUSE_PRINTING_ARCHITECTURE
#error "You must set wxUSE_PRINTING_ARCHITECTURE to 1 in setup.h, and recompile the library."
#endif

#include <ctype.h>
#include "wx/metafile.h"
#include "wx/printdlg.h"
#include "wx/image.h"
#include "wx/accel.h"

#ifdef __WXMAC__
#include "wx/mac/printdlg.h"
#endif

#if wxUSE_LIBGNOMEPRINT
#include "wx/html/forcelnk.h"
FORCE_LINK(gnome_print)
#endif
//------------------------------------------------------------------------------
#include <f2fverbs/F2fVerbs.hpp>
#include "MainFrame.hpp"
//------------------------------------------------------------------------------
#include "config.hpp"
//------------------------------------------------------------------------------

class MainFrame;  //On déclare MainFrame avant pr pouvoir l'utiliser juste après.

class ScorePrintout : public wxPrintout
{
public:
    ScorePrintout();
    ScorePrintout(MainFrame *PtToMainFrame, wxString title);
    bool OnPrintPage(int page);
    bool HasPage(int page);
    bool OnBeginDocument(int startPage, int endPage);
    void GetPageInfo(int *minPage, int *maxPage, int *selPageFrom, int *selPageTo);

protected:
    wxString FormatTimeSpan(wxTimeSpan timeSpan);
    void DrawPageOne();

    F2fVerbs *m_F2fVerbs;
    MainFrame *m_PtToMainFrame;
};

#endif //PRINTING_HPP_FORBIDDEN_2_FORGET
